Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /config/releases/release-110.63/install.sh
ViewVC logotype

Diff of /config/releases/release-110.63/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

sml/branches/SMLNJ/config/install.sh revision 249, Sat Apr 17 18:57:03 1999 UTC config/trunk/install.sh revision 2150, Thu Nov 2 17:52:56 2006 UTC
# Line 1  Line 1 
1  #!/bin/sh  #!/bin/sh
2  #  #
3  # Copyright (c) 1994 AT&T Bell Laboratories.  # Copyright (c) 1994 AT&T Bell Laboratories.
4    # Copyright (c) 2003 The Fellowship of SML/NJ
5  #  #
6  # installation script for SML/NJ and related tools; this is a temporary  # Installation script for SML/NJ and related tools; this is a temporary
7  # placeholder until the configuration tool is finished.  # placeholder until the configuration tool is finished.
8  #  #
9    # Significant changes to take advantage of a new portable installer
10  #set -x  # script for everything after booting the interactive system.
   
11  #  #
12  # get the target list  # Author: Matthias Blume (blume@tti-c.org)
13  #  #
14  if [ ! -r config/targets ]; then  
15    echo "!!! no target list"  if [ x$1 = xnolib ] ; then
16    exit 1;      nolib=true
17    else
18        nolib=false
19  fi  fi
 . config/targets  
20    
21  #  if [ x${INSTALL_QUIETLY} = xtrue ] ; then
22  # some OSs have make in strange places      export CM_VERBOSE
23  #      CM_VERBOSE=false
24  MAKE=make  fi
25    
26    vsay() {
27        if [ x${INSTALL_DEBUG} = xtrue ] ; then
28            echo "$@"
29        elif [ x${INSTALL_QUIETLY} = xtrue ] ; then
30            :
31        else
32            echo "$@"
33        fi
34    }
35    
36    complain() {
37        echo "$@"
38        exit 1
39    }
40    
41    this=$0
42    
43    
44  #  #
45  # command for building SML libraries; this should be either  # create the preloads.standard file
 # "CM.recompile()" or "CM.stabilize true".  The latter builds  
 # stable libraries, which may be somewhat faster to use.  
46  #  #
47  #CM_MAKE_LIB="CM.recompile();"  if [ ! -r config/preloads ]; then
48  CM_MAKE_LIB="CM.stabilize true;"      complain "$this: !!! File config/preloads is missing."
49    fi
50    cp config/preloads preloads.standard
51    
52  #  #
53  # check for ksh  # Some OSs have make in strange places, but most of the time it is
54  #  # simply on the PATH:
 # ksh causes some people problems so we will always use /bin/sh  
55  #  #
56  #echo "checking for ksh"  MAKE=make
57  #if [ -x /bin/ksh ]; then  
 #  SHELL=/bin/ksh  
 #elif [ -x /usr/local/bin/ksh ]; then  
 #  SHELL=/usr/local/bin/ksh  
 #else  
58    SHELL=/bin/sh    SHELL=/bin/sh
59  #fi  vsay $this: Using shell $SHELL.
 echo "  using $SHELL"  
60    
61  #  #
62  # set the SML root directory  # set the SML root directory
63  #  #
64  REAL_PWD=`pwd`  REAL_PWD=`pwd`
65  ROOT=${PWD:-$REAL_PWD}  ROOT=${PWD:-$REAL_PWD}
66  echo "SML root is $ROOT"  vsay $this: SML root is $ROOT.
67    
68    cd "${INSTALLDIR:=$ROOT}"
69    INSTALLDIR=`pwd`
70    cd "$ROOT"
71    vsay $this: Installation directory is ${INSTALLDIR}.
72    
73  #  #
74  # set the various directory pathname variables  # set the various directory and file pathname variables
75  #  #
76  BINDIR=$ROOT/bin  BINDIR=$INSTALLDIR/bin          # main dir for binary stuff
77  CONFIGDIR=$ROOT/config  CONFIGDIR=$ROOT/config
78  HEAPDIR=$BINDIR/.heap  HEAPDIR=$BINDIR/.heap           # where heap images live
79  RUNDIR=$BINDIR/.run  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live
80  SRCDIR=$ROOT/src  SRCDIR=$ROOT/base/src           # where the source tree is rooted
81  LIBDIR=$ROOT/lib  LIBDIR=$INSTALLDIR/lib          # where libraries live
82    
83  #  #
84  # the paths to ml-yacc and ml-lex; needed to configure CM  # files to be deleted after we are done...
85    #
86    tmpfiles=""
87    tmpfiles="$tmpfiles preloads.standard"
88  #  #
89  YACCPATH=$BINDIR/ml-yacc  # make sure we always clean up after ourselves...
90  LEXPATH=$BINDIR/ml-lex  #
91  BURGPATH=$BINDIR/ml-burg  trap 'cd "$ROOT"; rm -f $tmpfiles' 0 1 2 3 15
92    
93    
94  #  #
95  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
96  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
97  #  -M.Blume (5/1998)  # Especially important is CM_PATHCONFIG.
98  #  #
99  CM_YACC_DEFAULT=$YACCPATH  export CM_PATHCONFIG
100  CM_LEX_DEFAULT=$LEXPATH  CM_PATHCONFIG=$LIBDIR/pathconfig
 CM_BURG_DEFAULT=$BURGPATH  
 CM_PATH_DEFAULT=.:$LIBDIR  
 export CM_YACC_DEFAULT CM_LEX_DEFAULT CM_BURG_DEFAULT CM_PATH_DEFAULT  
   
101  #  #
102  # the release version that we are installing  # the release version that we are installing
103  #  #
104  VERSION=`cat $CONFIGDIR/version`  VERSION=`cat "$CONFIGDIR/version"`
105  echo "installing version $VERSION"  vsay $this: Installing version $VERSION.
106    
107  #  #
108  # create the various sub directories  # the URL for the (usually remote) source archive
109  #  #
110  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR  . "$CONFIGDIR"/srcarchiveurl
111  do  vsay $this: URL of source archive is $SRCARCHIVEURL.
112    if [ -d $dir ]; then  
113      echo "$dir already exists"  #
114    else  # Function to make a directory including its ancestors.
115      echo "creating $dir"  #
116      mkdir $dir  makedir() {
117      if [ $? != "0" ]; then      if [ x"$1" = x ] ; then
118        echo "unable to create $dir"          :
119        exit 1      elif [ -d "$1" ] ; then
120            :
121        else
122            makedirtmp=`dirname "$1"`
123            makedir "$makedirtmp"
124            if [ x${INSTALL_VERBOSE} = xtrue ] ; then
125                vsay "$this: Making directory $1"
126      fi      fi
127            if mkdir "$1" ; then
128                :
129            else
130                complain "$this: !!! Unable to make directory $1!"
131    fi    fi
132  done      fi
133    }
134    
135  #  #
136  # install the script that tests the architecture, and make sure that it works  # Fish out the CM metadata directory name from library files
137    # and store it in ORIG_CM_DIR_ARC.
138    # The single argument is the name of the directory containing
139    # a single subdirectory which is a CM metadata directory:
140  #  #
141  if [ -x $BINDIR/.arch-n-opsys ]; then  fish() {
142    echo "$BINDIR/.arch-n-opsys already exists"      cd "$1"
143        ORIG_CM_DIR_ARC=unknown
144        for i in * .[a-zA-Z0-9]* ; do
145            if [ -d $i ] ; then
146                ORIG_CM_DIR_ARC=$i
147                break
148            fi
149        done
150        if [ $ORIG_CM_DIR_ARC = unknown ] ; then
151            complain "$this: could not determine CM metadata directory name"
152  else  else
153    cat $CONFIGDIR/_arch-n-opsys | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys          echo "$this: CM metadata directory name is \"${ORIG_CM_DIR_ARC}\""
   chmod 555 $BINDIR/.arch-n-opsys  
   if [ ! -x $BINDIR/.arch-n-opsys ]; then  
     echo "!!! installation of $BINDIR/.arch-n-opsys failed for some reason"  
     exit 1  
154    fi    fi
155    }
156    
157    
158    # A function to move all stable library files to a parallel directory
159    # hierarchy.
160    # The first argument must be a simple path (no / inside), and
161    # the second argument must be an absolute path.
162    move() {
163        if [ -L "$1" ] ; then
164            rm -f "$1"           # remove symbolic link made by diracs (see below)
165        elif [ -d "$1" ] ; then
166            if [ ! -d "$2" ] ; then
167                if [ -f "$2" ] ; then
168                    complain $this: $2 exists as a non-directory.
169                fi
170                mkdir "$2"
171            fi
172            cd "$1"
173            for i in * .[a-zA-Z0-9]* ; do
174                move "$i" "$2"/"$i"
175            done
176            cd ..
177        elif [ -f "$1" ] ; then
178            rm -f "$2"
179            mv "$1" "$2"
180        fi
181    }
182    
183    #
184    # Traverse the directory tree rooted at $3 (must be single arc!).
185    # Find all directories named $1, rename them into $2 and make
186    # and establish $1 as a symbolic link to $2:
187    #
188    dirarcs() {
189        if [ -d "$3" ] ; then
190            if [ "$3" = "$1" ] ; then
191                mv "$1" "$2"
192                ln -s "$2" "$1"
193            else
194                cd "$3"
195                for d in * .[a-zA-Z0-9]* ; do
196                    dirarcs "$1" "$2" "$d"
197                done
198                cd ..
199            fi
200        fi
201    }
202    
203    
204    ######################################################################
205    
206    #
207    # create the various sub directories
208    #
209    for dir in "$BINDIR" "$HEAPDIR" "$RUNDIR" "$LIBDIR" "$SRCDIR" ; do
210        makedir "$dir"
211    done
212    
213    #
214    # Function to install a "driver" script...
215    #   This takes care of patching the source of the script with the SHELL,
216    #   BINDIR, and VERSION variables to use.
217    #
218    installdriver() {
219        dsrc=$1
220        ddst=$2
221    # We install the driver unconditionally. (It would be better to test
222    # for an outdated driver script, but not all "test" commands understand
223    # the -nt comparison operator....)
224    #   if [ -x $BINDIR/$ddst ]; then
225    #       echo $this: Script $BINDIR/$ddst already exists.
226    #   else
227            rm -f "$BINDIR"/"$ddst"
228            cat "$CONFIGDIR"/"$dsrc" | \
229            sed -e "s,@SHELL@,$SHELL,g" \
230                -e "s,@BINDIR@,$BINDIR," \
231                -e "s,@VERSION@,$VERSION," \
232                -e "s,@CMDIRARC@,${CM_DIR_ARC:-dummy}," \
233                > "$BINDIR"/"$ddst"
234            chmod 555 "$BINDIR"/"$ddst"
235            if [ ! -x "$BINDIR"/"$ddst" ]; then
236                complain "$this: !!! Installation of $BINDIR/${ddst} failed."
237  fi  fi
238  ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  #   fi
239    }
240    
241    #
242    # install the script that tests architecture and os...
243    #
244    installdriver _arch-n-opsys .arch-n-opsys
245    
246    #
247    # run it to figure out what architecture and os we are using, define
248    # corresponding variables...
249    #
250    ARCH_N_OPSYS=`"$BINDIR"/.arch-n-opsys`
251  if [ "$?" != "0" ]; then  if [ "$?" != "0" ]; then
252    echo "!!! $BINDIR/.arch-n-opsys fails on this machine"      echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."
253    echo "!!! you must patch this by hand and repeat the installation"      echo "$this: !!! You must patch this by hand and repeat the installation."
254    exit 2    exit 2
255  else  else
256    echo "$BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS"      vsay $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.
257  fi  fi
258  eval $ARCH_N_OPSYS  eval $ARCH_N_OPSYS
259    
260  if [ -x $BINDIR/.run-sml ]; then  #
261    echo "$BINDIR/.run-sml already exists"  # now install most of the other driver scripts
262  else  #  (except ml-build, since we don't know $CM_DIR_ARC yet)
263    cat $CONFIGDIR/_run-sml | \  #
264      sed -e "s,@SHELL@,$SHELL,g" -e "s,@BINDIR@,$BINDIR," -e "s,@VERSION@,$VERSION," \  installdriver _run-sml .run-sml
265      > $BINDIR/.run-sml  installdriver _link-sml .link-sml
266    chmod 555 $BINDIR/.run-sml  installdriver _ml-makedepend ml-makedepend
267    if [ ! -x $BINDIR/.run-sml ]; then  
268      echo "!!! installation of $BINDIR/.run-sml failed for some reason"  installdriver _heap2exec heap2exec
     exit 1  
   fi  
 fi  
269    
270  #  #
271  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
272  #  #
273  case $ARCH in  case $ARCH in
274    mips*) ALLOC=1M ;;      mips*)
275            ALLOC=1M
276            ;;
277    x86)    x86)
278            # The following is the _wrong_ value for many popular x86 chips
279            # (i.e., Celerons).  However, the optimal value for those is 32k,
280            # and such a small value is not enough for the runtime system's boot
281            # code.  Therefore, we use 256k here and re-set it to the proper
282            # value in .run-sml.
283      ALLOC=256k      ALLOC=256k
284    ;;    ;;
285    alpha32)    alpha32)
# Line 155  Line 289 
289      ALLOC=512k      ALLOC=512k
290    ;;    ;;
291  esac  esac
292    
293  case $OPSYS in  case $OPSYS in
294    solaris)    solaris)
295      MAKE=/usr/ccs/bin/make      MAKE=/usr/ccs/bin/make
# Line 162  Line 297 
297    linux)    linux)
298      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`      EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`
299      if [ "$?" != "0" ]; then      if [ "$?" != "0" ]; then
300        echo "problems checking for underscores in global names"              complain "$this: !!! Problems checking for underscores in asm names."
       exit 1  
301      fi      fi
302      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"      EXTRA_DEFS="XDEFS=$EXTRA_DEFS"
303    ;;    ;;
# Line 172  Line 306 
306  #  #
307  # the name of the bin files directory  # the name of the bin files directory
308  #  #
309  BIN_FILES=bin.$ARCH-unix  BOOT_ARCHIVE=boot.$ARCH-unix
310    BOOT_FILES=sml.$BOOT_ARCHIVE
311    
312  #  #
313  # build the run-time system  # build the run-time system
314  #  #
315  $CONFIGDIR/unpack.sh "run-time" $SRCDIR runtime $ROOT/$VERSION-runtime.tar  if [ -x "$RUNDIR"/run.$ARCH-$OPSYS ]; then
316  if [ "$?" != "0" ]; then      vsay $this: Run-time system already exists.
317    exit $?  else
318  fi      "$CONFIGDIR"/unpack "$ROOT" runtime
319  if [ ! -x $RUNDIR/run.$ARCH-$OPSYS ]; then      cd "$SRCDIR"/runtime/objs
320    cd $SRCDIR/runtime/objs      echo $this: Compiling the run-time system.
   echo "compiling the run-time system"  
321    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS    $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
322    if [ -x run.$ARCH-$OPSYS ]; then    if [ -x run.$ARCH-$OPSYS ]; then
323      mv run.$ARCH-$OPSYS $RUNDIR          mv run.$ARCH-$OPSYS "$RUNDIR"
324            if [ -f runx.$ARCH-$OPSYS ]; then
325                mv runx.$ARCH-$OPSYS "$RUNDIR"
326            fi
327            if [ -f run.$ARCH-$OPSYS.so ]; then
328                mv run.$ARCH-$OPSYS.so "$RUNDIR"
329            fi
330            if [ -f run.$ARCH-$OPSYS.a ]; then
331                mv run.$ARCH-$OPSYS.a "$RUNDIR"
332            fi
333      $MAKE MAKE=$MAKE clean      $MAKE MAKE=$MAKE clean
334    else    else
335      echo "!!! run-time system build failed for some reason"          complain "$this: !!! Run-time system build failed for some reason."
     exit 1  
336    fi    fi
337  fi  fi
338  cd $SRCDIR  cd "$SRCDIR"
339    
340  #  #
341  # boot the base SML system  # boot the base SML system
342  #  #
343  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r "$HEAPDIR"/sml.$HEAP_SUFFIX ]; then
344    echo "$HEAPDIR/sml.$HEAP_SUFFIX already exists"      vsay $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
345  else      fish "$LIBDIR"/smlnj/basis
346    $CONFIGDIR/unpack.sh bin $ROOT $BIN_FILES $ROOT/$VERSION-$BIN_FILES.tar      # ignore requested arc name since we have to live with what is there:
347    cd $ROOT      export CM_DIR_ARC
348    $RUNDIR/run.$ARCH-$OPSYS @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX      CM_DIR_ARC=$ORIG_CM_DIR_ARC
349      $SET_FLAGS      # now re-dump the heap image:
350      val use = Compiler.Interact.useFile      vsay "$this: Re-creating a (customized) heap image..."
351      val _ = (SMLofNJ.exportML "sml";      "$BINDIR"/sml @CMredump "$ROOT"/sml
352               print Compiler.banner;      cd "$ROOT"
              print "\n");  
 XXXX  
353    if [ -r sml.$HEAP_SUFFIX ]; then    if [ -r sml.$HEAP_SUFFIX ]; then
354      mv sml.$HEAP_SUFFIX $HEAPDIR          mv sml.$HEAP_SUFFIX "$HEAPDIR"
     cd $BINDIR  
     ln -s .run-sml sml  
355    else    else
356      echo "!!! unable to build SML heap image (sml.$HEAP_SUFFIX)"          complain "$this !!! Unable to re-create heap image (sml.$HEAP_SUFFIX)."
     exit 1  
357    fi    fi
358    else
359        "$CONFIGDIR"/unpack "$ROOT" "$BOOT_ARCHIVE"
360    
361        fish "$ROOT"/"$BOOT_FILES"/smlnj/basis
362    
363        cd "$ROOT"
364    
365        # Target arc:
366        export CM_DIR_ARC
367        CM_DIR_ARC=${CM_DIR_ARC:-".cm"}
368    
369        if [ $CM_DIR_ARC = $ORIG_CM_DIR_ARC ] ; then
370            : we are happy
371        else
372            # now we have to make a symbolic link for each occurrence of
373            # $ORIG_CM_DIR_ARC to $CM_DIR_ARC
374            dirarcs "$ORIG_CM_DIR_ARC" "$CM_DIR_ARC" "$BOOT_FILES"
375  fi  fi
376    
377        cd "$ROOT"/"$BOOT_FILES"
378    
379        # now link (boot) the system and let it initialize itself...
380        if "$BINDIR"/.link-sml @SMLheap="$ROOT"/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
381        then
382            cd "$ROOT"
383            if [ -r sml.$HEAP_SUFFIX ]; then
384                mv sml.$HEAP_SUFFIX "$HEAPDIR"
385                cd "$BINDIR"
386                ln -s .run-sml sml
387  #  #
388  # now build the individual targets              # Now move all stable libraries to #LIBDIR and generate
389                # the pathconfig file.
390  #  #
391  cd $SRCDIR              cd "$ROOT"/"$BOOT_FILES"
392  echo "install targets"              for anchor in * ; do
393  for i in $TARGETS                  if [ -d $anchor ] ; then
394  do                      echo $anchor $anchor >>$CM_PATHCONFIG
395    if [ $i = "doc" ]; then                      move $anchor "$LIBDIR"/$anchor
     TARGET=$i  
   else  
     TARGET=$i.$HEAP_SUFFIX  
   fi  
   if [ -r $HEAPDIR/$TARGET ]; then  
     echo "$TARGET already exists"  
   else  
     echo "  building $TARGET"  
     case $i in  
       src-smlnj)  
         for src in compiler comp-lib cm MLRISC; do  
           $CONFIGDIR/unpack.sh $src $ROOT/src $src $ROOT/$VERSION-$src.tar  
         done  
       ;;  
       sml-full)  
         if [ ! -d $ROOT/$BIN_FILES ]; then  
           echo "!!! bin files are missing; build of $TARGET failed"  
           exit 1  
         else  
           cd $ROOT  
           $RUNDIR/run.$ARCH-$OPSYS @SMLfull @SMLboot=$ROOT/$BIN_FILES @SMLalloc=$ALLOC <<XXXX  
             $SET_FLAGS  
             val use = Compiler.Interact.useFile  
             val _ = (SMLofNJ.exportML "sml-full";  
                      print Compiler.banner;  
                      print " [full]\n");  
 XXXX  
           if [ -r sml-full.$HEAP_SUFFIX ]; then  
             mv sml-full.$HEAP_SUFFIX $HEAPDIR  
             cd $BINDIR  
             ln -s .run-sml sml-full  
           else  
             echo "!!! unable to build SML-FULL heap image"  
             exit 1  
           fi  
         fi  
       ;;  
       ml-yacc)  
         $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc  
         ./build  
         if [ -r src/$TARGET ]; then  
           mv src/$TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
       ;;  
       ml-lex)  
         $CONFIGDIR/unpack.sh ML-Lex $SRCDIR ml-lex $ROOT/$VERSION-ml-lex.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-lex  
         ./build  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
           fi  
         else  
           echo "!!! build of $TARGET failed"  
           exit 1  
         fi  
       ;;  
       ml-burg)  
         $CONFIGDIR/unpack.sh ML-Burg $SRCDIR ml-burg $ROOT/$VERSION-ml-burg.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-burg  
         ./build  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
396            fi            fi
397                done
398                cd "$ROOT"
399                # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
400                rm -rf "$BOOT_FILES"
401    
402          else          else
403            echo "!!! build of $TARGET failed"              complain "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."
           exit 1  
         fi  
       ;;  
       smlnj-lib)  
         $CONFIGDIR/unpack.sh "SML/NJ Library" $SRCDIR smlnj-lib $ROOT/$VERSION-smlnj-lib.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
       # make the Util library  
         cd $SRCDIR/smlnj-lib/Util  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/smlnj-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Util/sources.cm" > smlnj-lib.cm  
         fi  
       # make the Unix library  
         cd $SRCDIR/smlnj-lib/Unix  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/unix-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Unix/sources.cm" > unix-lib.cm  
         fi  
       # make the HTML library  
         cd $SRCDIR/smlnj-lib/HTML  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/html-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/HTML/sources.cm" > html-lib.cm  
         fi  
       # make the Reactive library  
         cd $SRCDIR/smlnj-lib/Reactive  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/reactive-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/Reactive/sources.cm" > reactive-lib.cm  
         fi  
       # make the PP library  
         cd $SRCDIR/smlnj-lib/PP  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/pp-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/PP/sources.cm" > pp-lib.cm  
         fi  
       # make the RegExp library  
         cd $SRCDIR/smlnj-lib/RegExp  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/regexp-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/smlnj-lib/RegExp/sources.cm" > regexp-lib.cm  
         fi  
       ;;  
       ml-yacc-lib)  
         $CONFIGDIR/unpack.sh ML-Yacc $SRCDIR ml-yacc $ROOT/$VERSION-ml-yacc.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/ml-yacc/lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/ml-yacc-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/ml-yacc/lib/sources.cm" > ml-yacc-lib.cm  
         fi  
       ;;  
       cml)  
         $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/cml/src  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/src/sources.cm" > cml.cm  
         fi  
       ;;  
       cml-lib)  
         $CONFIGDIR/unpack.sh CML $SRCDIR cml $ROOT/$VERSION-cml.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/cml/cml-lib  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/cml-lib.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/cml/cml-lib/sources.cm" > cml-lib.cm  
         fi  
       ;;  
       cml-cm)  
         CMD="CM.autoloading(SOME true); CM.clearAutoList();"  
         CMD="$CMD CM.autoload'(\"$LIBDIR/cml.cm\");"  
         if [ "$AUTOLOAD_CML_LIB" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/cml-lib.cm\");"  
         fi  
         if [ "$AUTOLOAD_EXENE" = "TRUE" ]; then  
           CMD="$CMD CM.autoload'(\"$LIBDIR/eXene.cm\");"  
         fi  
         cd $ROOT  
         $BINDIR/sml <<XXXX  
           $CMD  
           val _ = (SMLofNJ.exportML "$i";  
                 print CML.banner;  
                 print "[CML autoload]\n");  
 XXXX  
         if [ -r $TARGET ]; then  
           mv $TARGET $HEAPDIR  
           if [ ! -f $BINDIR/$i ]; then  
             cd $BINDIR  
             ln -s .run-sml $i  
404            fi            fi
405          else          else
406            echo "!!! unable to build autoloading CML"          complain "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."
           exit 1  
407          fi          fi
       ;;  
       eXene)  
         $CONFIGDIR/unpack.sh EXene $SRCDIR eXene $ROOT/$VERSION-eXene.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $SRCDIR/eXene  
         echo "$CM_MAKE_LIB" | $BINDIR/sml  
         if [ ! -f $LIBDIR/eXene.cm ]; then  
           cd $LIBDIR  
           echo "Alias $SRCDIR/eXene/sources.cm" > eXene.cm  
         fi  
       ;;  
       doc)  
         $CONFIGDIR/unpack.sh Doc $ROOT doc $ROOT/$VERSION-doc.tar  
         if [ "$?" != "0" ]; then  
           exit $?  
         fi  
         cd $ROOT/doc  
         build $ROOT  
       ;;  
       *)  
         echo "!!! unknown target $i"  
       ;;  
     esac  
408    fi    fi
 done  
409    
410  if [ "$ENABLE_AUTOLOADING" = "TRUE" ]; then  #
411    CMD="CM.autoloading(SOME true); CM.clearAutoList();"  # now that we know CM_DIR_ARC we can install the ml-build driver...
412    if [ "$AUTOLOAD_SMLNJ_LIB" = "TRUE" ]; then  #
413      CMD="$CMD CM.autoload'(\"$LIBDIR/smlnj-lib.cm\");"  installdriver _ml-build ml-build
414    fi  
415    if [ "$AUTOLOAD_SMLNJ_UNIX" = "TRUE" ]; then  cd "$ROOT"
416      CMD="$CMD CM.autoload'(\"$LIBDIR/unix-lib.cm\");"  
417    fi  #
418    if [ "$AUTOLOAD_SMLNJ_HTML" = "TRUE" ]; then  # Now do all the rest using the precompiled installer:
419      CMD="$CMD CM.autoload'(\"$LIBDIR/html-lib.cm\");"  #
420    fi  if [ $nolib = false ] ; then
421    if [ "$AUTOLOAD_SMLNJ_REACTIVE" = "TRUE" ]; then      echo $this: Installing other libraries and programs:
422      CMD="$CMD CM.autoload'(\"$LIBDIR/reactive-lib.cm\");"      export ROOT INSTALLDIR CONFIGDIR BINDIR
423    fi      if "$BINDIR"/sml -m \$smlnj/installer.cm
424    if [ "AUTOLOAD_SMLNJ_PP" = "TRUE" ]; then      then
425      CMD="$CMD CM.autoload'(\"$LIBDIR/pp-lib.cm\");"          vsay $this: Installation complete.
   fi  
   if [ "AUTOLOAD_SMLNJ_REGEXP" = "TRUE" ]; then  
     CMD="$CMD CM.autoload'(\"$LIBDIR/regexp-lib.cm\");"  
   fi  
   cd $ROOT  
   $BINDIR/sml <<XXXX  
     $CMD  
     val _ = (SMLofNJ.exportML "sml";  
              print Compiler.banner;  
              print " [CM; autoload enabled]\n");  
 XXXX  
   if [ -r sml.$HEAP_SUFFIX ]; then  
     mv sml.$HEAP_SUFFIX $HEAPDIR  
426    else    else
427      echo "!!! unable to build SML with autoloading"          complain "$this: !!! Installation of libraries and programs failed."
     exit 1  
428    fi    fi
429  fi  fi
430    
431    exit 0

Legend:
Removed from v.249  
changed lines
  Added in v.2150

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0